<Cabbage> bounds(0, 0, 0, 0)
form caption("simpLSampLr") size(860, 460), guiMode("queue"), pluginId("def1") colour(black) typeface("./roboto-mono/RobotoMono-Bold.ttf")

label bounds(410, 10, 27, 16) text("Ch.") fontColour(255, 255, 255, 255)
;label bounds(522, 10, 50, 16) text("choke") fontColour(255, 255, 255, 255)
label bounds(584, 10, 50, 16) text("speed") fontColour(255, 255, 255, 255)
label bounds(646, 10, 50, 16) text("pan") fontColour(255, 255, 255, 255)
label bounds(706, 10, 55, 16) text("volume") fontColour(255, 255, 255, 255)
label bounds(797, 10, 55, 16) text("global") fontColour(255, 255, 255, 255)

combobox bounds(5, 5, 95, 20), populate("*.snaps"), channel("combo1") channelType("string") value("0.0") automatable(0) colour(255, 255, 255, 255) fontColour(0, 0, 0, 255)
filebutton bounds(104, 4, 25, 20), text("+", "+"), populate("*.snaps"),mode("named preset") channel("filebutton1") colour:0(29, 152, 0, 255)
filebutton bounds(132, 5, 25, 20), text("-", "-"), populate("*.snaps", "test"), mode("remove preset") channel("filebutton6") colour:0(166, 0, 0, 255)

image bounds(800, 30, 50, 395) channel("global_Image") colour(159, 65, 37, 255) corners(10)
label bounds(800, 30, 50, 20) text("volume") fontColour(255, 255, 255, 128) fontSize(12)
vmeter bounds(815, 50, 10, 75) channel("global_MeterL") value(0) outlineColour(255, 255, 255,0), overlayColour(0, 0, 0) meterColour:0(255, 0, 0) meterColour:1(255, 255, 0) meterColour:2(0, 255, 0) outlineThickness(1)
vmeter bounds(825, 50, 10, 75) channel("global_MeterR") value(0) outlineColour(255, 255, 255,0), overlayColour(0, 0, 0) meterColour:0(255, 0, 0) meterColour:1(255, 255, 0) meterColour:2(0, 255, 0) outlineThickness(1)
vslider bounds(815, 50, 20, 75) channel("global_Volume") range(0, 1, 1, 0.5, 0.001)  trackerColour(0, 0, 0, 128) colour(255, 255, 255, 255) alpha(0.4)

</Cabbage>
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4
</CsOptions>
<CsInstruments>
; Initialize the global variables. 
ksmps = 32
nchnls = 2
0dbfs = 1

instr SampleSlot
    iNoteNumber = p4
    iSlotNumber = iNoteNumber+1
    
    iLabel_Pad = (iNoteNumber % 15) + 1
    iName = iNoteNumber % 12
    iOct = iNoteNumber / 12
    SLabel_Name[] fillarray "C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"
    iLabel_Oct[] genarray -2,8,1
    ipads_row[] genarray 5, 305, 100
    ipads_col[] genarray 30, 330, 100
    ipads_col[] sortd ipads_col
    iX = ipads_row[iNoteNumber%4]
    iY = ipads_col[iNoteNumber/4]
    iEditY = 30 + (iSlotNumber-1)*25
    
    SPad_SoundFilerCode sprintf "bounds(%d, %d, 91, 91), colour(180, 130, 0, 255) tableBackgroundColour(214, 170, 0, 255), channel(\"pad_SoundFiler%d\"), file(\"./samples/%d.wav\")", iX+2, iY+2, iSlotNumber, iSlotNumber
    SPad_ImageCode sprintf "bounds(%d, %d, 95, 95) colour(0,0,0,0) outlineThickness(5), corners(10), outlineColour(160,160,160,255), channel(\"pad_Image%d\")", iX, iY, iSlotNumber
    SPad_LabelNumCode sprintf "bounds(%d, %d, 40, 30) text(\"%d\"), fontColour(\"white\"), channel(\"pad_LabelNum%d\"), fontSize(30), align(left)", iX+5, iY, iSlotNumber, iSlotNumber
    SPad_LabelNameCode sprintf "bounds(%d, %d, 40, 30) text(\"%s%d\"), fontColour(0,0,0,128), channel(\"pad_LabelName%d\"), fontSize(16), align(left)", iX+5, iY+65, SLabel_Name[iName], iLabel_Oct[iOct], iSlotNumber
    SPad_ClearTrigCode sprintf "bounds(%d, %d, 95, 95) text(\"\") colour(0,0,0,0) corners(10) channel(\"pad_ClearTrig%d\")", iX, iY, iSlotNumber
    
    SEdit_ImageCode sprintf "bounds(410, %d, 380, 20) channel(\"edit_Image%d\") colour(159, 120, 37, 255) corners(10)", iEditY, iSlotNumber
    SEdit_LabelCode sprintf "bounds(414, %d, 20, 20) channel(\"edit_Label%d\") text(\"%d\") fontColour(255, 255, 255, 255) fontSize(14)", iEditY, iSlotNumber, iSlotNumber
    SEdit_PlayCode sprintf "bounds(442, %d, 12, 12) channel(\"edit_Play%d\"), imgFile(\"On\", \"./imgs/playButton.png\"), imgFile(\"Off\", \"./imgs/playButton.png\")", iEditY+4, iSlotNumber
    SEdit_MuteCode sprintf "bounds(468, %d, 20, 14) channel(\"edit_Mute%d\") text(\"M\", \"M\") colour:0(154, 154, 154, 255) colour:1(221, 59, 59, 255) fontColour:0(0, 0, 0, 255) fontColour:1(0, 0, 0, 255)", iEditY+3, iSlotNumber
;    SEdit_SoloCode sprintf "bounds(490, %d, 20, 14) channel(\"edit_Solo%d\") text(\"S\", \"S\") colour:0(154, 154, 154, 255) colour:1(255, 202, 0, 255) fontColour:0(0, 0, 0, 255) fontColour:1(0, 0, 0, 255)", iEditY+3, iSlotNumber
;    SEdit_ChokeCode sprintf "bounds(526, %d, 40, 16) channel(\"edit_Choke%d\") colour(190, 190, 190, 255) text(\"none\", \"1\", \"2\", \"3\", \"4\", \"5\", \"6\", \"7\", \"8\", \"9\", \"10\", \"11\", \"12\", \"13\", \"14\", \"15\", \"16\") fontColour(0, 0, 0, 255)", iEditY+2, iSlotNumber
    SEdit_SpeedCode sprintf "bounds(580, %d, 60, 20) channel(\"edit_Speed%d\") range(0.001, 4, 1, 0.5, 0.001)  trackerColour(108, 180, 255, 255) colour(190, 190, 190, 255)", iEditY, iSlotNumber
    SEdit_PanCode sprintf "bounds(640, %d, 60, 20) channel(\"edit_Pan%d\") range(0, 1, 0.5, 1, 0.001)  trackerColour(130, 192, 95, 255) colour(190, 190, 190, 255)", iEditY, iSlotNumber
    SEdit_VolumeCode sprintf "bounds(700, %d, 60, 20) channel(\"edit_Volume%d\") range(0, 1, 1, 0.5, 0.001)  trackerColour(255, 140, 140, 255) colour(190, 190, 190, 255)", iEditY, iSlotNumber
    SEdit_MeterLCode sprintf "bounds(768, %d, 6, 20) channel(\"edit_MeterL%d\") value(0) outlineColour(255, 255, 255,0), overlayColour(0, 0, 0) meterColour:0(255, 0, 0) meterColour:1(255, 255, 0) meterColour:2(0, 255, 0) outlineThickness(1)", iEditY, iSlotNumber
    SEdit_MeterRCode sprintf "bounds(774, %d, 6, 20) channel(\"edit_MeterR%d\") value(0) outlineColour(255, 255, 255,0), overlayColour(0, 0, 0) meterColour:0(255, 0, 0) meterColour:1(255, 255, 0) meterColour:2(0, 255, 0) outlineThickness(1)", iEditY, iSlotNumber
    
    cabbageCreate "soundfiler", SPad_SoundFilerCode
    cabbageCreate "image", SPad_ImageCode
    cabbageCreate "label", SPad_LabelNumCode
    cabbageCreate "label", SPad_LabelNameCode
    cabbageCreate "label", SPad_ClearTrigCode
    
    cabbageCreate "image", SEdit_ImageCode
    cabbageCreate "label", SEdit_LabelCode
    cabbageCreate "button", SEdit_PlayCode
    cabbageCreate "button", SEdit_MuteCode
;    cabbageCreate "button", SEdit_SoloCode
;    cabbageCreate "combobox", SEdit_ChokeCode
    cabbageCreate "hslider", SEdit_SpeedCode
    cabbageCreate "hslider", SEdit_PanCode
    cabbageCreate "hslider", SEdit_VolumeCode
    cabbageCreate "vmeter", SEdit_MeterLCode
    cabbageCreate "vmeter", SEdit_MeterRCode

    SSoundFilerCh sprintf "pad_SoundFiler%d", iSlotNumber
    SFileCh sprintf "sample%d", iSlotNumber
    SImageCh sprintf "pad_Image%d", iSlotNumber
    SLabelNumCh sprintf "pad_LabelNum%d", iSlotNumber
    SLabelNameCh sprintf "pad_LabelName%d", iSlotNumber
    SClearTrigCh sprintf "pad_ClearTrig%d", iSlotNumber
    
    SPlayCh sprintf "edit_Play%d", iSlotNumber
    
    SFile sprintf "./samples/%d.wav", iSlotNumber
    
    kBounds[] cabbageGet SImageCh, "bounds"
    kX chnget "MOUSE_X"
    kY chnget "MOUSE_Y"
    
    kMouseDownClearTrig, kClearTrig cabbageGetValue SClearTrigCh
    
    if kClearTrig == 1 then
        event "i", 1, 0, 1, iSlotNumber
    endif
    
    SFile, kFileChanged cabbageGet "LAST_FILE_DROPPED"
    SCurrentWidget, kWidgetChanged cabbageGet "CURRENT_WIDGET"
    
    if kFileChanged == 1 then
        if kX > kBounds[0] && kX < kBounds[0]+kBounds[2] && kY > kBounds[1] && kY < kBounds[1]+kBounds[3] then
            cabbageSet kFileChanged, SSoundFilerCh, "file", SFile
            chnset SFile, SFileCh
        endif
    endif
    
endin

instr 1
    iSlotNumber = p4
    SFile sprintf "./samples/%d.wav", iSlotNumber
    SFileCh sprintf "sample%d", iSlotNumber
    SMuteCh sprintf "edit_Mute%d", iSlotNumber
    SSoloCh sprintf "edit_Solo%d", iSlotNumber
    SSpeedCh sprintf "edit_Speed%d", iSlotNumber
    SPanCh sprintf "edit_Pan%d", iSlotNumber
    SVolumeCh sprintf "edit_Volume%d", iSlotNumber
    SMeterLCh sprintf "edit_MeterL%d", iSlotNumber
    SMeterRCh sprintf "edit_MeterR%d", iSlotNumber
    
    chnset SFile, SFileCh
    
;   KEEP GARBAGE OUT
    kDummyEnv madsr .01, 0, 1, filelen(chnget:S(SFileCh))
    
    aL, aR diskin2 chnget:S(SFileCh), chnget:i(SSpeedCh), 0, 0

;   PAN
    if chnget:i(SPanCh) <= 0.5 then
        aL = aL
        aR = aR * (chnget:i(SPanCh))*2
    elseif chnget:i(SPanCh) >= 0.5 then
        aL = aL*((chnget:i(SPanCh))-1)*-1*2
        aR = aR
    endif
    
;   MUTE
    aL = aL * ( (chnget:i(SMuteCh)) - 1 ) * -1
    aR = aR * ( (chnget:i(SMuteCh)) - 1 ) * -1
      
;   SOLO

;   CHOKE

;   VOLUME
    aL = aL * (chnget:i(SVolumeCh))
    aR = aR * (chnget:i(SVolumeCh))
    
;   CHANNEL METERS
    kL rms aL
    kR rms aR
    cabbageSetValue SMeterLCh, portk(sqrt(kL*2), .1), changed(kL)
    cabbageSetValue SMeterRCh, portk(sqrt(kR*2), .1), changed(kR)
    
;   GLOBAL VOLUME
    aL = aL * (chnget:i("global_Volume"))
    aR = aR * (chnget:i("global_Volume"))
    outs aL, aR
    
;   GLOBAL METERS
    kL rms aL
    kR rms aR
    cabbageSetValue "global_MeterL", portk(sqrt(kL*2), .1), changed(kL)
    cabbageSetValue "global_MeterR", portk(sqrt(kR*2), .1), changed(kR)
    
endin

</CsInstruments>
<CsScore>

i"SampleSlot" 0 z 0
i"SampleSlot" 0 z 1
i"SampleSlot" 0 z 2
i"SampleSlot" 0 z 3
i"SampleSlot" 0 z 4
i"SampleSlot" 0 z 5
i"SampleSlot" 0 z 6
i"SampleSlot" 0 z 7
i"SampleSlot" 0 z 8
i"SampleSlot" 0 z 9
i"SampleSlot" 0 z 10
i"SampleSlot" 0 z 11
i"SampleSlot" 0 z 12
i"SampleSlot" 0 z 13
i"SampleSlot" 0 z 14
i"SampleSlot" 0 z 15

;causes Csound to run for about 7000 years...
f0 z
</CsScore>
</CsoundSynthesizer>
